Imports outlk = Microsoft.Office.Interop.outlook
Imports mediatheek.Data
Imports Mediatheek.dataacces

Public Class clsOutlook

    'controleert bij alle ontleningen of ze te laat zijn en zend email indien nodig
    Public Shared Sub checkAllesTeLaat(ByVal arlOntleningen As ArrayList)

        Dim sVandaag As Date
        sVandaag = Today

        For Each oOntlening As clsOntlening In arlOntleningen

            If Date.Compare(sVandaag, oOntlening.DatumUit) < 0 Then
                zendMail(oOntlening)
            Else
                Debug.WriteLine("ontlening:" & oOntlening.OntleningId & " van ontlener: " & oOntlening.OntlenerId & " is nog niet te laat")
            End If

        Next
      




    End Sub


    Public Shared Sub zendMail(ByVal oOntlening As clsOntlening)

        Dim oOutlook As outlk._Application
        oOutlook = New outlk.Application

        Dim oOntlener As clsOntlener
        oOntlener = clsOntlenerDA.GetOntlenersById(oOntlening.OntlenerId).Item(0)

        Dim oAlbum As clsAlbum
        oAlbum = clsAlbumDA.GetAlbumByID(oOntlening.AlbumId).Item(0)

        Dim sVandaag As Date
        sVandaag = Today

        Try

            ' nieuw mailitem
            Dim oMail As outlk._MailItem
            oMail = oOutlook.CreateItem(outlk.OlItemType.olMailItem)
            oMail.Subject = "Ontleenperiode van " & oAlbum.AlbumNaam & " overschreden."

            'bericht
            oMail.Body = _
            "Geachte " & oOntlener.VoorNaam & " " & oOntlener.AchterNaam & "," _
            & vbCr & vbCr & "Uw toegelaten ontleningsperiode is verstreken." _
            & vbCr & vbCr & _
            "Op " & oOntlening.DatumUit & " ontleende U " & oAlbum.AlbumNaam _
            & " van " & clsFichegenerator.getGroepNaam(oAlbum) & " en deze moest teruggebracht zijn op " & oOntlening.DatumIn _
            & vbCr & vbCr & _
            "Vandaag is het " & sVandaag & ".  Gelieve dit album zo vlug mogelijk terug te brengen." _
            & vbCr & vbCr & vbCr & vbCr & _
            "mvg," & vbCr & vbCr & _
            "Mediatheek Ontleningsdienst"

            ' adres ontlener
            oMail.To = oOntlener.Email



            'mail verzenden
            oMail.Send()

            ' Clean up
            oOutlook = Nothing
            oMail = Nothing

            MsgBox("E-mail verzonden naar " & oOntlener.VoorNaam & " " & oOntlener.AchterNaam _
            & " (" & oOntlener.Email & ")", MsgBoxStyle.OKOnly, "E-mail verzonden.")

        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.OKCancel, "Fout bij het verzenden van e-mail naar " & oOntlener.Email & " .")
        End Try

    
    End Sub

  

End Class
